(*********************************************************************)
(**  Pilsner: A Compositionally Verified Compiler for a             **)
(**  Higher-Order Imperative Language                               **)
(**                                                                 **)
(**  For copyright and license, see LICENSE.txt.                    **)
(**  For anything else, see README.txt.                             **)
(*********************************************************************)

(* TODO: rewriting printing of code and README.txt, and provide awkward.tgt. *)

open Parser
open Pils_tgt
open Zwickel


let compile infile outfile : unit =
  let cin = open_in infile in
  let lexbuf = Lexing.from_channel cin in
  let (imports, msrc) = Parser.annotated_modul Lexer.token lexbuf in
  let mtgt = tr_mod imports msrc in
  save_module mtgt outfile
;;


let _ =
  compile Sys.argv.(1) Sys.argv.(2)
;;
