(*********************************************************************)
(**  Pilsner: A Compositionally Verified Compiler for a             **)
(**  Higher-Order Imperative Language                               **)
(**                                                                 **)
(**  For copyright and license, see LICENSE.txt.                    **)
(**  For anything else, see README.txt.                             **)
(*********************************************************************)

Require Import Arith Bool List.
Require Import vgtac basis ssr.
Require Import lang_src_lsi lang_spec lang_tgt.
Require Import model model_common model_properties gw util.

Set Implicit Arguments. 
Global Set Bullet Behavior "Strict Subproofs".



Lemma ts_gw_vclos_closed: forall (w: world_loca ts_gw) s r ty va vb
    (VC: vclos (wlift w) s r ty va vb)
    x (FV: fv_exp vb x),
  False.
Proof.
  i; invc VC REL; try rrdes CB; eauto.
  - rrdes VR; destruct vb; ss; subst; vauto.
  - invc VR; rrdes CB; eauto.
Qed.



Lemma ts_pesim_return: forall (lw: world_loca ts_gw) (r: esimtyp (wlift lw))
   i ka kb ty vb g si s
   (RV: vclos (wlift lw) s (g s) ty (ts_rf s r_arg) vb)
   (EXT: extpub _ s si),
 pesim r i ka kb g si s true ty
   {| cpc := Just ka; crf := Nothing; cst := pmemp; chp := pmemp |}
   (pmemp, Nothing, Just (app_cont kb vb)).
Proof.
  i; pfold; econs; i; esplits; eauto.
  eapply esim_ret; eauto; rr; eauto.
Qed.












































































































































